%%% 12. Resources

%%% clp(fd) is great with resource constrained problems.

%%% Scheduling problems are often a repeated series of resource constraint problems.

%%% Most such problems can be worked with the primitive constraints, but a couple built in clp(fd) constraints are useful. sum/3 and scalar_product/4 are fairly straightforward.

%%% The use of scalar_product/4 might not be obvious. It is useful for defining relationships where different things have different costs (in time, money, or something else).

%% Penny Candy

%
%  penny candy example
%  Timmy has 25 cents
%  gumballs cost a penny
%  snickers cost 10 cents
%  toffees are 2 cents
%  licorice costs 5 cents
%
%  what are Timmys alternatives?
%  assume Timmy spends the entire 25 cents

:- use_module(library(clpfd)).

scalar_test(Candy) :-
        Candy = [_Gumball, _Snickers, _Toffee, _Licorice],
        Candy ins 1..sup, % 0 or 1 or 2 ...
        scalar_product([1, 10, 2, 5], Candy, #=, 25),
        label(Candy).

% ?- scalar_test([Gumball, Snickers, Toffee, Licorice]).
